{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 02-04-2007
  Versión actual: 1.0.0
  Fecha versión actual: 02-04-2007
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit InformeListadoProcedencias;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, InformeBase, FR_IBXDB, FR_Shape, FR_Class, DB, IBCustomDataSet,
  IBQuery, FR_DSet, FR_DBSet, RdxEmpresaActiva;

type
  TdmInformeListadoProcedencias = class(TdmInformeBase)
    dsTablaInforme: TfrDBDataSet;
    TablaInforme: TIBQuery;
  protected
    procedure RellenarCabecera(Band: TfrBand); override;
    procedure PrepararConsultas; override;
  public
    constructor Create(AOwner: TComponent); override;
  end;

var
  dmInformeListadoProcedencias: TdmInformeListadoProcedencias;

implementation
{$R *.dfm}

{ TdmInformeListadoFacturacionProcedencia }

constructor TdmInformeListadoProcedencias.Create(AOwner: TComponent);
begin
  inherited;
  FNombreInforme := 'ListadoProcedencias.frf';
end;

procedure TdmInformeListadoProcedencias.PrepararConsultas;
begin
  inherited;
  with TablaInforme do
  begin
    Database := FBaseDatos;
    Transaction := FTransaccion;
    SQL.Clear;
    SQL.Add('SELECT PROCEDENCIAS.CODIGO, ');
    SQL.Add('COALESCE(PROCEDENCIAS.DESCRIPCION, ''DESCONOCIDA'') as DESCRIPCION, ');
    SQL.Add('COUNT(CLIENTES.CODIGO) as NUM_CLIENTES');
    SQL.Add('FROM PROCEDENCIAS');
    SQL.Add('FULL OUTER JOIN CLIENTES ON (CLIENTES.PROCEDENCIA = PROCEDENCIAS.CODIGO) ');
    SQL.Add('GROUP BY 1,2 ');
    SQL.Add('ORDER BY 3 DESC');
    Prepare;
  end;
end;

procedure TdmInformeListadoProcedencias.RellenarCabecera(Band: TfrBand);
var
  iCont : Integer;
  Objeto : TfrView;
begin
  inherited;
{
  with Band do
  begin
     for iCont := 0 to Objects.Count - 1 do
      begin
        Objeto := Objects[iCont];
        if ((Objeto is TfrMemoView) and (Objeto.Name = 'CabParametros')) then
        begin
          with (Objeto as TfrMemoView) do
          begin
            Memo.Clear;
            Memo.Add('Rango de fechas: ' + DateToStr(FFechaIni) + ' - ' + DateToStr(FFechaFin));
          end;
        end;
      end;
  end;
}  
end;

end.

